=== debian/changelog ===
libcgns (4.5.0-1) unstable; urgency=medium

  * Team upload.
  * upload cgns 4.5 to unstable (transition Bug#1119273)
  * delete debian/gbp.conf (not needed for master branch)

 -- Drew Parsons <dparsons@debian.org>  Tue, 28 Oct 2025 20:06:22 +0100

libcgns (4.5.0-1~exp6) experimental; urgency=medium

  * Team upload.
  * replace debian patch fix_C_fortran_interface_PR881.patch with
    _PR882.patch applying upstream's preferred solution, PR#882.

 -- Drew Parsons <dparsons@debian.org>  Mon, 20 Oct 2025 18:00:23 +0200

libcgns (4.5.0-1~exp5) experimental; urgency=medium

  * Team upload.
  * debian patch fix_C_fortran_interface_PR881.patch applies upstream
    PR#881 to fix handling of the C-fortran interface. Closes: #1118026.

 -- Drew Parsons <dparsons@debian.org>  Fri, 17 Oct 2025 16:47:57 +0200

libcgns (4.5.0-1~exp4) experimental; urgency=medium

  * Team upload.
  * debian patch improve_tests_PR880.patch applies upstream PR#880
    aiming to improve tests (including cgwrite_f03, albeit without the
    CG_CONFIG_GET_MAXIMUM_FILES patch, which is not present in 4.5.0)
    See Bug#1118026.

 -- Drew Parsons <dparsons@debian.org>  Wed, 15 Oct 2025 17:12:53 +0200

libcgns (4.5.0-1~exp3) experimental; urgency=medium

  * Team upload.
  * debian/rules: use DEB_HOST_GNU_TYPE not DEB_HOST_MULTIARCH to
    access build dirs. See Debhelper perl scripts (Buildsystem.pm)
    Needed to distinguish i686 from i386, else i386 fails tests.
  * libcgns-dev provides cgns_f.F90 in /usr/src/cgns, to allow use with
    other (non-GNU) Fortran compilers. Closes: #1054229.

 -- Drew Parsons <dparsons@debian.org>  Mon, 13 Oct 2025 18:08:53 +0200

libcgns (4.5.0-1~exp2) experimental; urgency=medium

  * Team upload.
  * debian patch fix_test_particlef_PR876.patch applies upstream
    PR#876 to fix segfaults in test_particlef. Closes: #1117937.

 -- Drew Parsons <dparsons@debian.org>  Mon, 13 Oct 2025 11:12:26 +0200

libcgns (4.5.0-1~exp1) experimental; urgency=medium

  * Team upload.
  * New upstream release
    - updates to ABI 4.5
    - builds with tk 9. Closes: #1066704
    - builds with gcc-15. Closes: #1097171
    - raises minimum cmake version. Closes: #1113127
    - provides cmake config scripts (libcgns-dev)
  * debian patch cmake_gnuinstalldirs_PR843.patch applies upstream
    PR#843 to ensure GNUInstallDirs are properly used to install
    library files in arch-triplet dirs
  * update debian patch cgnstools-path.patch to use
    tools_install_suffix to install cgnstools data files
  * update installed docs (HISTORY.txt, RELEASE.md)
  * update libcgns4.5.symbols using patch from dpkg-gensymbols
    (manually replace debian revision with upstream version 4.5.0)
  * Build-Depends: debhelper-compat (= 13)
  * Standards-Version: 4.7.2

 -- Drew Parsons <dparsons@debian.org>  Sat, 11 Oct 2025 20:15:16 +0200
