=== debian/rules ===
#!/usr/bin/make -f

# Enable all hardening flags
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# CGNS_ENABLE_SCOPING doens't seem compatible with CGNS_ENABLE_FORTRAN,
# causing FTBFS
# CGNS_ENABLE_64BIT=OFF: keeping the previous release setting
CMAKE_EXTRA_FLAGS := \
	-DCGNS_BUILD_CGNSTOOLS=ON \
	-DCGNS_BUILD_SHARED=ON \
	-DCGNS_ENABLE_64BIT=OFF \
	-DCGNS_ENABLE_BASE_SCOPE=ON \
	-DCGNS_ENABLE_FORTRAN=ON \
	-DCGNS_ENABLE_HDF5=ON \
	-DCGNS_ENABLE_LEGACY=ON \
	-DCGNS_ENABLE_SCOPING=OFF \
	-DCGNS_ENABLE_TESTS=ON \
	-DCGNS_USE_SHARED=ON \
	-DFORTRAN_NAMING=LOWERCASE_ \

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ --no-parallel

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_EXTRA_FLAGS)

override_dh_auto_test:
	LD_LIBRARY_PATH=$(CURDIR)/obj-$(DEB_HOST_GNU_TYPE)/src dh_auto_test

override_dh_install:
	dh_install
	rm -fr debian/cgns-convert/usr/bin/cgnstools
	rm -f debian/cgns-convert/usr/bin/cgconfig
	# Rename usr/bin/unitconv (name already used by package xcrysden)
	cd debian/cgns-convert/usr/bin && mv unitconv cgns_unitconv

override_dh_compress:
	dh_compress -X.pdf
