=== debian/watch ===
version=4
opts="filenamemangle=s/.*\/v/@PACKAGE@-/" \
	https://github.com/CGNS/CGNS/tags \
	.*/v([\d\.]+).tar.gz
